package eu.osci.internal.messagetypes;

import java.io.ByteArrayInputStream;
import java.net.URL;

import org.junit.Test;

import com.sun.xml.ws.api.security.trust.client.STSIssuedTokenConfiguration;
import com.sun.xml.ws.security.trust.STSIssuedTokenFeature;
import com.sun.xml.ws.security.trust.impl.client.DefaultSTSIssuedTokenConfiguration;

import eu.osci.helper.EndpointLocator;
import eu.osci.messagetypes.MessageParent;
import eu.osci.messagetypes.OSCIRequest;


public class STSConfigurated extends MessageParent
{

  @Test
  public void testSTSAppliesTo() throws Exception
  {
    EndpointLocator endpointLocator = new EndpointLocator(new URL(URL_WSDL_USER));
    endpointLocator.usePort("LetterStyle");
    DefaultSTSIssuedTokenConfiguration config = new DefaultSTSIssuedTokenConfiguration();
    config.getOtherOptions().put(STSIssuedTokenConfiguration.APPLIES_TO, "sonstwo");
    // config.getOtherOptions().put(STSIssuedTokenConfiguration.LIFE_TIME, 100);

    STSIssuedTokenFeature feature = new STSIssuedTokenFeature(config);
    OSCIRequest req = new OSCIRequest(endpointLocator, feature);
    ByteArrayInputStream encData = new ByteArrayInputStream(XML_ENC_DATA.getBytes());
    req.sendMessage(encData);

  }
}
