package eu.osci.messagetypes;

import java.io.IOException;
import java.security.GeneralSecurityException;
import java.security.KeyStore;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.SocketFactory;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManagerFactory;

import eu.osci.helper.CryptoTools;


public class HttpsTransport
{


  public HttpsTransport()
  {
  }

  private KeyStore getSslKeyStore() throws IOException, GeneralSecurityException
  {

    KeyStore ks = KeyStore.getInstance(KeyStore.getDefaultType());

    // get user password and file input stream
    char[] password = new char[1];
    ks.load(null, password);

    return ks;
  }

  private X509Certificate getServersSslCert() throws CertificateException
  {
    return CryptoTools.loadCertificate(getClass().getResourceAsStream("/governikus_ssl_cert.crt"));

    // return config.getCurrentEndpoint().getEncryptionCertificate();
  }

  private char[] getSslKeyPass()
  {
    return "4307".toCharArray();
  }

  /**
   * Create an SSLSocketFactory which supports client authentication.
   * 
   * @throws GeneralSecurityException
   * @throws IOException
   */
  public SSLSocketFactory getSSLFactory() throws GeneralSecurityException, IOException
  {
    SSLContext ctx = SSLContext.getInstance("TLS");
    SocketFactory factory = SSLSocketFactory.getDefault();

    KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
    TrustManagerFactory tmf = TrustManagerFactory.getInstance("SunX509");

    kmf.init(getSslKeyStore(), getSslKeyPass());
    KeyStore trustStore = KeyStore.getInstance("jks");
    trustStore.load(null, null);
    trustStore.setCertificateEntry("alias", getServersSslCert());

    tmf.init(trustStore);

    ctx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), new SecureRandom());
    return ctx.getSocketFactory();
  }

  /**
   * Needed if servers SSL certificate does not match the servers host name - may be the case in test systems
   */
  public HostnameVerifier createNullHostnameVerifier()
  {
    return new HostnameVerifier()
    {

      @Override
      public boolean verify(String arg0, SSLSession arg1)
      {
        if (arg0.equals("localhost") || arg0.equals("127.0.0.1"))
          return true;
        else
          return false;
      }
    };
  }
}
