package eu.osci.messagetypes;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.logging.Logger;

import org.junit.Test;

import eu.osci.ErrorTextTranslation;


/**
 * Tests the error codes of the specification. In the most test methods an OSCIException will be thrown.<br>
 * Copyright  2010 Freie Hansestadt Bremen. <br>
 * Created by bremen online services Entwicklungs- und Betriebsgesellschaft mbH & Co. KG. <br>
 * This library (Starter Kit) can be used by anybody according to the Bremer Lizenz fr freie
 * Softwarebibliotheken. The license terms can be viewed at www.osci.de or can be ordered at the
 * OSCI-Leitstelle (Die Senatorin fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40, 28015 Bremen).
 * 
 * @author R. Lindemann
 */
public class TestErrorMessages extends MessageParent
{

  private static final Logger LOG = Logger.getLogger(TestErrorMessages.class.getName());

  /**
   * Forces an IllegalStateException because the FetchRequest object is empty.
   */
  @Test
  public void testErrorSendRequest() throws Exception
  {
    try
    {
      OSCIMsgBoxFetchRequest rspRequest = new OSCIMsgBoxFetchRequest();
      rspRequest.sendRequest();
    }
    catch (IllegalStateException ex)
    {
      String expectedConstant = ErrorTextTranslation.NO_SELECTION_PARAMETER.getConstant();
      assertEquals("Wrong value. ", "noSelectionPara", expectedConstant);
      assertNotNull("Translation message was null. ", ex.getLocalizedMessage());
      // Expected exception
    }
  }
}
